%define releasebase 1 
%define nbase open-mx

#Use as deafults if no command line inputs
%define as_limulus 1
# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%define targetbase Limulus
%endif

%define prefix /usr/%{nbase}
# Define kernel here. For example
# if uname -r is "3.12.2-1.el6.elrepo.x86_64"
# then set the following defines and
# use "_" instead of "-" so rpmbuild will not gag
%define hard_krelease 3.12.2_1 
# % define hard_krelease 3.19.0_1

%define arch_tag el6.elrepo.x86_64

#ewquires kernel-ml-devel
Summary: Open-MX (MX for Ethernet) 
Version: 1.5.4
Name: %{nbase}
License: GPL
Group: %{targetbase}/Libaries
Release: %{releasebase}.%{targetbase}.%{hard_krelease}
Source: open-mx-%{version}.tar.gz
Patch0: open-mx-local-install.patch
URL: http://open-mx.gforge.inria.fr/ 
Distribution: Scientific Linux 
Vendor: Basement Supercomputing
Packager: deadline@basement-supercomputing.com
%define ver %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Provides: libmyriexpress.a  libmyriexpress.so  libopen-mx.a  libopen-mx.so
%description
Open-MX is a high-performance implementation of the Myrinet Express 
message-passing stack over generic Ethernet networks. It provides 
application-level with wire-protocol compatibility with the native 
MXoE (Myrinet Express over Ethernet) stack.

At least MPICH-MX, MPICH2-MX, Open MPI and PVFS2 build natively on 
top of Open-MX thanks to the MX API compatibility. 
%prep 
%setup -n open-mx-%{version}
%patch0 -p0
KREL=`uname -r |sed 's!.%{arch_tag}!!'`
HARD_KREL=`uname -r |sed 's!.%{arch_tag}!!'|sed 's!-!_!'`
if [ "$HARD_KREL" != "%{hard_krelease}" ] ; then
echo "Set hard_krelease to match this machine"
exit 1
fi
LINPATH=`ls -d /usr/src/kernels/$KREL*`
#./configure --prefix=%{prefix} --disable-mx-wire  --disable-endian --with-mtu=1500 --with-linux=$LINPATH
#./configure --prefix=%{prefix} --disable-mx-wire  --disable-endian --with-mtu=3000 --with-linux=$LINPATH
./configure --prefix=%{prefix} --disable-mx-wire  --disable-endian --with-mtu=4096 --with-linux=$LINPATH

%build

make

%install
mkdir -p %{buildroot}/etc/udev/rules.d
mkdir -p %{buildroot}/etc/rc.d/init.d
mkdir -p %{buildroot}/etc/ld.so.conf.d
make  DESTDIR=%{buildroot} install
DESTDIR=%{buildroot} %{buildroot}/%{prefix}/sbin/omx_local_install
# include ld.so.conf.d
cat <<EOF >>%{buildroot}/etc/ld.so.conf.d/%{name}-%{version}.conf
%{prefix}/lib
EOF
%pre
HARD_KREL=`uname -r |sed 's!.%{arch_tag}!!'|sed 's!-!_!'`
# echo "HARD_KREL $HARD_KREL"
# echo "hardrelease  %{hard_krelease}"
if [ "$HARD_KREL" != "%{hard_krelease}" ] ; then
REAL_KREL=`echo %{hard_krelease}|sed 's!_!-!'`
THIS_MACHINE=`uname -r |sed 's!.%{arch_tag}!!'`
echo "WARNING: Kernel Module mis-match. This open-mx version requres kernel $REAL_KREL.el6.x86_64"
echo "The kernel version running on this machine is $THIS_MACHINE"
fi

%post
/sbin/ldconfig 2>/dev/null

%preun
/etc/rc.d/init.d/open-mx stop &> /dev/null
%postun
/sbin/ldconfig 2>/dev/null

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
%{prefix}
%config(noreplace)
%{_sysconfdir}/ld.so.conf.d/%{name}-%{version}.conf
%{_sysconfdir}/open-mx/open-mx.conf
%{_sysconfdir}/udev/rules.d/10-open-mx.rules
%{_sysconfdir}/rc.d/init.d

%doc README COPYING COPYING.GPL COPYING.LGPL REPORTING-BUGS TODO AUTHORS
%changelog
* Fri Jan 30 2015 Douglas Eadline <deadline@basement-supercomputing.com>
- update to 1.5.4
* Tue Sep 25 2012 - Douglas Eadline <deadline@basement-supercomputing.com>
- module clean up
